#!/usr/bin/env python

# -*- coding: utf8 -*- 

#***********************************************************************
# pysycache : a program for learn to use the mouse
# Copyright (C) 2005-2006 Vincent DEROO (vincent.pysycache@free.fr) 
# 
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version. 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software 
# Foundation, Inc. : 
# 51 Franklin Street, Fifth Floor, Boston, MA02110-1301, USA
#***********************************************************************



#*******************************************************************************
# Importation des modules
#*******************************************************************************
import sys
import getopt, string
import random
import time
import locale

import random
import os.path
import pygame
from pygame.locals import *

#from datasclass import BtnOfApplicationOLD
import const
import datas
from pysyclasses import *
import pysymenu
import pysyselect
import pysyadmin









#*******************************************************************************
# Main of the program                                                          #
# parameters    typfull = 0 : in window                                        #
#                       = 1 : fullscreen                                       #
#*******************************************************************************
def main(typfull):
	random.seed()

	#lecture du fichier de configuration de pysycache
	ReadConfigPysycache()

	#----------------- recuperation du repertoire de l'application -------------
	str = os.path.abspath(sys.argv[0])
	(const.GRepPysycache, filename) = os.path.split(str)

	if const.GDebug == 1:
		print ""
		print "Directory of application : ", const.GRepPysycache

	#----------------- recuperation de l'encodage des console ------------------
	const.GConsoleLocale = sys.stdout.encoding
	if const.GDebug == 1:
		print ""
		print "Console encoding : ", const.GConsoleLocale

	if const.GAdmin == 1:
		#mode administration
		pysyadmin.ShowWindow(typfull)
	else:
		#verification de l'existence des repertoires necessaires a pysycache
		try:
			if const.GPysyUserMode == 1:
				if os.path.exists(const.GRepUsersPysycache) == False:
					if const.GDebug == 1:
						print ""
						print "the directory of users ( ", const.GRepUsersPysycache, " ) doesn't exist !"
					os.makedirs(const.GRepUsersPysycache)

			if os.path.exists(const.GRepScores) == False:
				if const.GDebug == 1:
					print ""
					print "the directory of scores ( ", const.GRepScores, " ) doesn't exist !"
				os.makedirs(const.GRepScores)
		
			myrep = os.path.join(const.GRepScores, 'themes-buttons')
			if os.path.isdir(myrep) == False:
				os.makedirs(myrep)
			myrep = os.path.join(const.GRepScores, 'themes-click')
			if os.path.isdir(myrep) == False:
				os.makedirs(myrep)
			myrep = os.path.join(const.GRepScores, 'themes-move')
			if os.path.isdir(myrep) == False:
				os.makedirs(myrep)
			myrep = os.path.join(const.GRepScores, 'themes-dblclick')
			if os.path.isdir(myrep) == False:
				os.makedirs(myrep)
			myrep = os.path.join(const.GRepScores, 'themes-puzzle')
			if os.path.isdir(myrep) == False:
				os.makedirs(myrep)

		except  Exception, err:
			print ""
			print ""
			print "*************************************************************"
			print "*"
			print '*           Error in directories creation : ', err
			print "*"
			print "*************************************************************"

		if const.GPysyUserMode == 0:
			#un joueur par utilisateur machine
			const.GRepPersoUser = os.path.join(os.path.expanduser("~"), "pysycache")  
			pysymenu.ShowWindow(typfull)
		elif const.GPysyUserMode == 1:
			#plusieurs joueur par utilisateur machine
			pysyselect.ShowWindow(typfull, 0)
		else:
			#le fichier de definition de pysycache n'a pas pu etre lu : on force l'administration
			pysyadmin.ShowWindow(typfull)

	screen = pygame.display.get_surface()

	#-------------------------------- fin du jeu -------------------------------
	const.Gbackground_image, background_rect = datas.Load_image('images', 'fond4.png')
	datas.ShowTransitionOfTheme(const.GDureeTransition, 'fond4.png')
	pygame.time.delay(1000)
	const.Gbackground_image, background_rect = datas.Load_image('images', 'fond5.png')
	datas.ShowTransitionOfTheme(const.GDureeTransition, 'fond5.png')

	#------------------ affichage des credits ------------------------
	myfont = os.path.join(const.GRepPysycache, 'fonts', 'FreeSansBold.ttf' )
	font = pygame.font.Font(myfont, 30)
	textcolor = 46, 113, 169

	#credits auteur
	fichier = os.path.join(const.GRepPysycache, 'lang', const.GMyLocale, 'credits.txt')
	if os.path.isfile(fichier):
		#afficher le contenu 
		f = open(fichier, 'r')
		lignes  = f.readlines()
		cptligne = 0
		for j in lignes:
			j = j.strip()
#			text = font.render(unicode(j, "utf-8"), 1, textcolor)
			text = font.render(j.decode("utf-8", "ignore"), 1, textcolor)
			screen.blit(text, (30, 30 + 40 * cptligne))	  
			cptligne += 1
		pygame.display.update()
		f.close()
		pygame.time.wait(3500) 


	#pub pour autres themes
	fichier = os.path.join(const.GRepPysycache, 'lang', const.GMyLocale, 'themes.txt')
	if os.path.isfile(fichier):
		const.Gbackground_image, background_rect = datas.Load_image('images', 'fond-themes.png')
		datas.ShowTransitionOfTheme(const.GDureeTransition, 'fond-themes.png')
		#afficher le contenu 
		f = open(fichier, 'r')
		lignes  = f.readlines()
		cptligne = 0
		for j in lignes:
			j = j.rstrip()
#			text = font.render(unicode(j, "utf-8"), 1, textcolor)
			text = font.render(j.decode("utf-8", "ignore"), 1, textcolor)
			screen.blit(text, (30, 30 + 40 * cptligne))	  
			cptligne += 1
		pygame.display.update()
		f.close()
		pygame.time.wait(3500) 

	#licence
	fichier = os.path.join(const.GRepPysycache, 'lang', const.GMyLocale, 'licences.txt')
	if os.path.isfile(fichier):
		const.Gbackground_image, background_rect = datas.Load_image('images', 'fond-licences.png')
		datas.ShowTransitionOfTheme(const.GDureeTransition, 'fond-licences.png')
		#afficher le contenu 
		f = open(fichier, 'r')
		lignes  = f.readlines()
		cptligne = 0
		for j in lignes:
			j = j.rstrip()
#			text = font.render(unicode(j, "utf-8"), 1, textcolor)
			text = font.render(j.decode("utf-8", "ignore"), 1, textcolor)
			screen.blit(text, (30, 30 + 40 * cptligne))	  
			cptligne += 1
		pygame.display.update()
		f.close()

	#credit des themes 
	if const.GWithCredits :
		pygame.time.wait(5000) 

		const.Gbackground_image, background_rect = datas.Load_image('images', 'fond5.png')
		datas.ShowTransitionOfTheme(const.GDureeTransition, 'fond5.png')

		#credit images for themes
		if const.GAdmin != 1:
			#credits de pysycache
			const.AppMove.ReadCreditOfDirectory(const.GRepPysycache)
			const.AppClick.ReadCreditOfDirectory(const.GRepPysycache)
			const.AppButtons.ReadCreditOfDirectory(const.GRepPysycache)
			const.AppDblClick.ReadCreditOfDirectory(const.GRepPysycache)
			const.AppPuzzle.ReadCreditOfDirectory(const.GRepPysycache)

			#credits des themes dans le rep des utilisateurs
			if const.GPysyUserMode == 0:
				#mode utilisateur simple
				const.AppMove.ReadCreditOfDirectory(const.GRepPersoUser)
				const.AppClick.ReadCreditOfDirectory(const.GRepPersoUser)
				const.AppButtons.ReadCreditOfDirectory(const.GRepPersoUser)
				const.AppDblClick.ReadCreditOfDirectory(const.GRepPersoUser)
				const.AppPuzzle.ReadCreditOfDirectory(const.GRepPersoUser)
			else:
				#mode multiutilisateurs
				for f in os.listdir(const.GRepUsersPysycache):
					dirname = os.path.join(const.GRepUsersPysycache, f)
					if (os.path.isdir(dirname)):
						const.AppMove.ReadCreditOfDirectory(dirname)
						const.AppClick.ReadCreditOfDirectory(dirname)
						const.AppButtons.ReadCreditOfDirectory(dirname)
						const.AppDblClick.ReadCreditOfDirectory(dirname)
						const.AppPuzzle.ReadCreditOfDirectory(dirname)






#*******************************************************************************
# Read the configuration file for the pysycache application                    #
#*******************************************************************************
def ReadConfigPysycache():
	filename = os.path.join("/", "etc", "pysycache", 'pysycache.dfg')

	if os.path.isfile(filename):
		pass
	else:
		filename = os.path.join("etc", "pysycache", 'pysycache.dfg')


	#lecture du fichier de definition
	if const.GDebug == 1:
		print ""
		print "Reading the .dfg file of pysycache...", filename

	if os.path.isfile(filename):
		f = open(filename, 'r')
		lignes  = f.readlines()
		for lig in lignes:
			lig = lig.strip()
			lig = lig.split('=')

			if len(lig) == 0:
				continue

			if string.upper(lig[0]) == 'USER' :
				#the type of user identification
				const.GPysyUserMode = int(lig[1])

			if string.upper(lig[0]) == 'SCORE' :
				#the type of user identification
				const.GRepScores = lig[1].decode("utf-8")

			if string.upper(lig[0]) == 'REPUSER' :
				#the directory of the users
				const.GRepUsersPysycache = lig[1].decode("utf-8")

		f.close()
	else:
		if const.GDebug == 1:
			print ""
			print "dfg file of pysycache not file..."
		const.GPysyUserMode = 999


	if const.GDebug == 1:
		print "User management  " + str(const.GPysyUserMode)
		print "Scores directory ", const.GRepScores 
		print "Users directory  ", const.GRepUsersPysycache



#*******************************************************************************
# Programme principal
#*******************************************************************************

#valeur par defaut
#const.GWithFullScreenInit = 1
#const.GWithSoundInit = 1
const.GWithCredits = 1
const.GWithHelp = 1
const.GDebug = 0
const.GAdmin = 0



# analyse des parametres passes en arguement
for opt in sys.argv:
	if const.GDebug == 1:
		print "option : ", opt

	if opt == '-nf':
		const.GPrefUserFromOptions.FullScreen = 0
	if opt == '-wf':
		const.GPrefUserFromOptions.FullScreen = 1
	if opt == '-ns':
		const.GPrefUserFromOptions.Sound = 0
		const.GWithSound = 0
	if opt == '-ws':
		const.GPrefUserFromOptions.Sound = 1
		const.GWithSound = 1
	if opt == '-nc':
		const.GWithCredits = 0
	if opt == '-nh':
		const.GWithHelp = 0
	if string.upper(opt[0:6]) == "-LANG=":
		const.GPrefUserFromOptions.Lang = opt[6:11]
	if opt == '-debug':
		const.GDebug = 1
		print "Mode debug"
	if opt == '-admin':
		const.GAdmin = 1

	if opt == '-h':
		datas.help_message()
	if opt == '--help':
		datas.help_message()
	if opt == '--version':
		print 'pysycache version 3.0'
		sys.exit(0)
	if opt == '--python-version':
		print 'Python '+ sys.version
		sys.exit(0)



#lancement de la boucle principale
if __name__ == '__main__': 
	main(const.GPrefUserFromOptions.FullScreen)
